/*--------------------------------------------------------------------.
| getscrapinfo.c                                                      |
|                                                                     |
| (c) 1997 Christopher Cave and Jonathan Hudson                       |
| This file is part of the freely distributable menu_rext c68 library |
| It may be distributed under the same terms as c68                   |
|                                                                     |
| Authors:                                                            |
|    Christopher Cave    <ccave@cix.compulink.co.uk>                  |
|    Jonathan Hudson     <jrhudson@bigfoot.com>                       |
| Bug fixes and improvements:                                         |
|    Thierry Godefroy    <godefroy@imaginet.fr>                       |
 --------------------------------------------------------------------*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <qdos.h>
#include <qptr.h>

#include "menu.h"
#include "menuP.h"

int GetScrapInfo (unsigned char *datatype,
                  unsigned short *modifycount,
                  unsigned long *buflen)
{
    int iret;

    SCRAPINFO si;

    si.dtyp.attr = THP_RET | THP_UBYT;
    si.dtyp.info = 0;
    si.dtyp.ptr = NULL;

    si.mcnt.attr = THP_RET | THP_UWRD;
    si.mcnt.info = 0;
    si.mcnt.ptr = NULL;

    si.bufl.attr = THP_RET | THP_ULNG;
    si.bufl.info = 0;
    si.bufl.ptr = NULL;

    iret = _use_scrap(INFO, &si);
    if (iret >= 0)
    {
        *datatype = *(unsigned char *) &si.dtyp.ptr;
        *modifycount = *(unsigned short *) &si.mcnt.ptr;
        *buflen = *(long *) &si.bufl.ptr;
    }
    else
        ReportError (iret, 0, 0, -1);

    return iret;
}
