/*--------------------------------------------------------------------.
| itemselect.c                                                        |
|                                                                     |
| (c) 1997 Christopher Cave and Jonathan Hudson                       |
| This file is part of the freely distributable menu_rext c68 library |
| It may be distributed under the same terms as c68                   |
|                                                                     |
| Authors:                                                            |
|    Christopher Cave    <ccave@cix.compulink.co.uk>                  |
|    Jonathan Hudson     <jrhudson@bigfoot.com>                       |
| Bug fixes and improvements:                                         |
|    Thierry Godefroy    <godefroy@imaginet.fr>                       |
 --------------------------------------------------------------------*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <qdos.h>
#include <qptr.h>

#include "menu.h"
#include "menuP.h"


int ItemSelect (char *name, char *prompt, char *item1, char *item2, char *item3,
                int xpos, int ypos, int mainc)
{
    int iret = -1;

    QD_TEXT (39) menustr;
    QD_TEXT (39) prmptstr;
    QD_TEXT (39) item1str;
    QD_TEXT (39) item2str;
    QD_TEXT (39) item3str;

    MENUITSL is;

    if (!item1)                 /* before we do any real work */
        return iret;
    else
        MOVEINS (&item1str, item1);

    is.xpos = xpos;
    is.ypos = ypos;
    is.mainc = mainc;
    is.retn.attr = THP_RET | THP_ULNG;
    is.retn.info = 0;
    is.retn.ptr = &iret;

    is.mennm.info = 0;
    if((long)name > 0)
    {
        is.mennm.attr = THP_CALL | THP_STR;
        is.mennm.ptr = &menustr;
        MOVEINS (&menustr, name);
    }
    else if (name == NULL)
    {
        is.mennm.attr = 0;
        is.mennm.ptr  = NULL;
    }
    else
    {
        is.mennm.attr = THP_CALL | THP_SLNG;
        is.mennm.ptr  = name;
    }

    is.prmpt.info = 0;
    if ((long)prompt > 0)
    {
        is.prmpt.attr = THP_CALL | THP_STR;
        is.prmpt.ptr = &prmptstr;
        MOVEINS (&prmptstr, prompt);
    }
    else if (prompt == NULL)
    {
        is.prmpt.attr = 0;
        is.prmpt.ptr  = NULL;
    }
    else
    {
        is.prmpt.attr = THP_CALL | THP_SLNG;
        is.prmpt.ptr = prompt;
    }

    is.item1.attr = THP_CALL | THP_STR;
    is.item1.info = 0;
    is.item1.ptr = &item1str;

    is.item2.info = 0;
    if (item2)
    {
        is.item2.attr = THP_CALL | THP_STR;
        is.item2.ptr = &item2str;
        MOVEINS (&item2str, item2);
    }
    else
    {
        is.item2.attr = 0;
        is.item2.ptr = NULL;
    }
    
    is.item3.info = 0;
    if (item3)
    {
        is.item3.attr = THP_CALL | THP_STR;
        is.item3.ptr = &item3str;
        MOVEINS (&item3str, item3);
    }
    else
    {
        is.item3.attr = 0;
        is.item3.ptr = NULL;
    }
    
    _use_qmenu(ITSL, &is);
    return iret;
}
