/*--------------------------------------------------------------------.
| viewfile.c                                                          |
|                                                                     |
| (c) 1997 Christopher Cave and Jonathan Hudson                       |
| This file is part of the freely distributable menu_rext c68 library |
| It may be distributed under the same terms as c68                   |
|                                                                     |
| Authors:                                                            |
|    Christopher Cave    <ccave@cix.compulink.co.uk>                  |
|    Jonathan Hudson     <jrhudson@bigfoot.com>                       |
| Bug fixes and improvements:                                         |
|    Thierry Godefroy    <godefroy@imaginet.fr>                       |
 --------------------------------------------------------------------*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <qdos.h>
#include <qptr.h>

#include "menu.h"
#include "menuP.h"

void ViewFile (char *fname, char *start, char *end, short nchars, int mainc, int listc)
{
    QD_TEXT (39) namestr;
    QD_TEXT (39) startstr;
    QD_TEXT (39) endstr;
    MENUVIEW v;

    if (fname)
    {
        v.filnm.attr = THP_CALL | THP_STR;
        v.filnm.info = 0;
        v.filnm.ptr = &namestr;
        MOVEINS (&namestr, fname);
    }
    else
    {
        return;
    }

    v.start.info = 0;
    if (start)
    {
        v.start.attr = THP_CALL | THP_STR;
        MOVEINS (&startstr, start);
        v.start.ptr = &startstr;
    }
    else
    {
        v.start.attr = 0;        
        v.start.ptr = NULL;
    }
    
    v.end.info = 0;
    if (end)
    {
        v.end.attr = THP_CALL | THP_STR;
        MOVEINS (&endstr, end);
        v.end.ptr = &endstr;
    }
    else
    {
        v.end.attr = 0;        
        v.end.ptr = NULL;
    }
     
    v.chars = nchars;
    v.mainc = mainc;
    v.listc = listc;

    _use_qmenu(VIEW, &v);
}
